package org.dusystems.oobiblio;

import java.io.*;
import java.util.Enumeration;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;
import java.util.jar.JarOutputStream;

/**
 * @author omikheev
 * @version $Id: JarUpdater.java,v 1.1 2007/12/03 23:43:17 cvsmihel Exp $
 */
public class JarUpdater {

	public static void updateJar(String jarName, String fileName) throws IOException {
		File jarFile = new File(jarName);
		String sNewName;
		int i = jarName.lastIndexOf('.');
		if (i != -1) {
			sNewName = jarName.substring(0, i) + System.currentTimeMillis() + jarName.substring(i);
		} else {
			sNewName = jarName + System.currentTimeMillis();
		}
		File newJarFile = new File(sNewName);
		JarFile jar = new JarFile(jarFile);
		try {
			JarOutputStream josNew =
					new JarOutputStream(new FileOutputStream(newJarFile));
			byte[] buffer = new byte[1024];
			int bytesRead;
			try {
				FileInputStream fis = new FileInputStream(fileName);
				try {
					JarEntry entry = new JarEntry(fileName.substring(fileName.lastIndexOf('/') + 1));
					josNew.putNextEntry(entry);
					while ((bytesRead = fis.read(buffer)) != -1) {
						josNew.write(buffer, 0, bytesRead);
					}
				}
				finally {
					fis.close();
				}
				for (Enumeration entries = jar.entries(); entries.hasMoreElements();) {
					JarEntry entry = (JarEntry) entries.nextElement();
					String sEntryName = fileName.substring(fileName.lastIndexOf('/') + 1);
					if (!entry.getName().equals(sEntryName)) {
						InputStream entryStream = jar.getInputStream(entry);
						josNew.putNextEntry(entry);
						while ((bytesRead = entryStream.read(buffer)) != -1) {
							josNew.write(buffer, 0, bytesRead);
						}
					}
				}
			}
			catch (Exception ex) {
				System.out.println(ex);
				josNew.putNextEntry(new JarEntry("stub"));
			}
			finally {
				josNew.close();
			}
		}
		finally {
			jar.close();
		}
		System.out.println(newJarFile + " created.");
	}
}
