package org.kobjects.jdbc;

import java.lang.reflect.Constructor;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Properties;

import org.kobjects.jdbc.ram.*;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 *
 * @author unascribed
 * @version 1.0
 */

public class TableManager {

	public static final int READ = 1;
	public static final int WRITE = 2;

	public static ResultSet getResultSet(
			String connector,
			int mode)
			throws ClassNotFoundException, SQLException {
		return (ResultSet) getAny(
				connector,
				mode == WRITE ? "OOSaxHandler" : "Reader",
				true);
	}

	public static ResultSet getResultSet(
			String type,
			String file,
			Properties properties,
			int mode)
			throws ClassNotFoundException, SQLException {

		return (ResultSet) getAny(
				type,
				file,
				properties,
				mode == WRITE ? "OOSaxHandler" : "Reader",
				true);
	}

	public static Table getTable(
			String type,
			String file,
			Properties properties)
			throws ClassNotFoundException, SQLException {
		return (Table) getAny(
				type,
				file,
				properties,
				"Table",
				true);
	}

	/**
	 * @param connector
	 * @return Table
	 */
	public static Table getTable(String connector)
			throws ClassNotFoundException, SQLException {
		return (Table) getAny(connector, "Table", true);
	}

	static Object getAny(
			String connector,
			String nameSuffix,
			boolean tryIndirect)
			throws ClassNotFoundException, SQLException {

		String name;
		String type;
		Properties properties = new Properties();

		int cut = connector.indexOf(':');

		if (cut == -1) {
			name = "";
			type = connector;
		} else {
			type = connector.substring(0, cut);
			name = connector.substring(cut + 1);
		}

		while (true) {
			int i0 = name.lastIndexOf(';');
			if (i0 == -1)
				break;
			int i1 = name.indexOf('=', i0);
			if (i1 == -1)
				throw new RuntimeException("illegal param format");
			String n =
					name.substring(i0 + 1, i1).trim().toLowerCase();
			String v = name.substring(i1 + 1).trim();
			name = name.substring(0, i0);

			properties.put(n, v);
		}

		return getAny(
				type,
				name,
				properties,
				nameSuffix,
				tryIndirect);
	}

	static Object getAny(
			String type,
			String file,
			Properties properties,
			String nameSuffix,
			boolean tryIndirect)
			throws ClassNotFoundException, SQLException {

		String className =
				"org.kobjects.jdbc.format."
						+ type
						+ "."
						+ Character.toUpperCase(type.charAt(0))
						+ type.substring(1)
						+ nameSuffix;

		try {
			Class cls = Class.forName(className);
			Constructor cons =
					cls.getConstructor(
							new Class[]{
									String.class,
									Properties.class});

			return cons.newInstance(
					new Object[]{file, properties});
		}
		catch (ClassNotFoundException e) {
			if (!tryIndirect)
				throw e;

			if (nameSuffix.equals("Table")) {

				return new RamTable(type, file, properties);

/*                throw new RuntimeException(
					e.toString()
						+ "; Auto RamTable generation NYI"); */
			} else {
				return (
						(Table) getAny(type,
								file,
								properties,
								"Table",
								false))
						.select();
			}
		}
		catch (Exception e) {
			throw new RuntimeException(e);
		}
	}
}

/*        
        int i0 = cut+1;
        
        while (cut < orig.length()) {
            int i1 = orig.indexOf(';', i0);
            if (i1 == -1) i1 = orig.length;
  */
