/*
 * Created on 27.10.2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.kobjects.jdbc.format.dbase;

import java.sql.SQLException;
import java.util.Vector;

import org.kobjects.jdbc.sql.SimpleExpr;

/**
 * Dbase functions having no matching/obvious equivalent in SQL.
 */
public class DbaseExpr extends SimpleExpr {

	static final int STR = 201;
	static final int SPACE = 202;
	static final int U = 203; // old strange topaz 'U' function

	int id;

	protected DbaseExpr(int id, Vector argV) {
		super(argV);
		this.id = id;
	}


	protected Object eval(Object[] args) throws SQLException {
		switch (id) {
			case STR: {
				StringBuffer buf = new StringBuffer(args[0].toString());
				int len = ((Number) args[1]).intValue();
				while (buf.length() < len) {
					buf.insert(0, " ");
				}
				return buf.toString();
			}
			case SPACE: {
				StringBuffer buf = new StringBuffer();
				int len = ((Number) args[0]).intValue();
				while (buf.length() < len) {
					buf.insert(0, " ");
				}
				return buf.toString();
			}
			case U:
				return u((String) args[0]);

			default:
				throw new RuntimeException("illegal type code:" + id);
		}
	}

	String u(String src) {
		StringBuffer buf = new StringBuffer();
		for (int i = 0; i < src.length(); i++) {
			char c = Character.toLowerCase(src.charAt(i));
			switch (c) {
				case '\u00e4':
					buf.append("ae");
					break;
				case '\u00f6':
					buf.append("oe");
					break;
				case '\u00fc':
					buf.append("ue");
					break;
				case '\u00df':
					buf.append("ss");
					break;
				default:
					buf.append(c);
			}

		}
		buf.setLength(src.length());

		System.out.println("u(" + src + ")=" + buf);

		return buf.toString();

	}


	public Class getType() {
		switch (id) {
			case STR:
			case SPACE:
			case U:
				return String.class;
			default:
				throw new RuntimeException("illegal type code:" + id);

		}
	}


	/* (non-Javadoc)
		 * @see org.kobjects.jdbc.sql.Expression#toString(int)
		 */
	public String toString(int sqlType) {
		switch (id) {
			case STR:
				return toString(sqlType, "STR");
			case SPACE:
				return toString(sqlType, "SPACE");
			case U:
				return toString(sqlType, "U");
			default:
				throw new RuntimeException("illegal type code:" + id);

		}
	}


}
