/*
 * Created on 24.05.2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.kobjects.jdbc.ram;

import java.sql.SQLException;
import java.util.Iterator;
import java.util.TreeSet;

import org.kobjects.jdbc.Order;
import org.kobjects.jdbc.util.AbstractTable;
import org.kobjects.jdbc.util.Index;

/**
 * @author haustein
 *         <p/>
 *         To change the template for this generated type comment go to
 *         Window>Preferences>Java>Code Generation>Code and Comments
 */
public class RamIndex implements Index {


	AbstractTable table;
	TreeSet index;
	Order definition;
	int size;
	int updateRow = -1;

	public RamIndex(AbstractTable table, Order definition) throws SQLException {
		this.table = table;
		this.definition = definition;
		size = definition.size();

		index = new TreeSet(definition);

		for (int i = 1; i <= table.getRowCount(); i++) {
			index.add(new Integer(i));
		}
	}


	public Order getOrder() {
		return definition;
	}


	public Iterator getIterator(Object[] startKey) throws SQLException {
		return (startKey == null ? index : index.tailSet(startKey)).iterator();
	}


	public Object getInternalKey(int row) throws SQLException {
		if (table.rowDeleted(row)) return null;
		Object[] value = new Object[size];
		Order o = definition;
		for (int j = 0; j < size; j++) {
			value[j] = table.get(row, o.getColumn().getNumber());
			o = o.getRemainder();
		}
		return value;
	}


	public void prepareUpdate(int row) throws SQLException {
		updateRow = row;
		deleteRow(row);
	}


	public void commitUpdate() throws SQLException {
		insertRow(updateRow);
		updateRow = -1;
	}


	public void insertRow(int row) throws SQLException {
		index.add(new Integer(row));
	}


	/* (non-Javadoc)
		 * @see org.kobjects.jdbc.util.Index#removeRow(int)
		 */
	public void deleteRow(int row) throws SQLException {
		index.remove(new Integer(row));
	}


}
