package org.kobjects.jdbc.sql;

import java.sql.SQLException;
import java.util.Hashtable;

import org.kobjects.jdbc.*;
import org.kobjects.jdbc.util.AbstractTable;

/**
 * @author Stefan Haustein
 */
public class ColumnExpr extends Expression {

	Column column;

	public ColumnExpr(Column column) {
		this.column = column;
	}

	public Object eval(int rowNumber, Object[] rowData) throws SQLException {
		if (rowData == null)
			return ((AbstractTable) column.getColumnSet()).get(rowNumber, column.getNumber());

		Object result = rowData[column.getNumber() - 1];
		return (result == null && getType() == String.class)
				? ""
				: result;
	}

	public String toString(int sqlType) {
//    	return column.getName().equalsIgnoreCase("number") ? '"'+column.getName()+'"' : column.getName();
		return '"' + column.getName() + '"';
	}

	public Object[] getRangeSupport(Hashtable ranges) {
		return (Object[]) ranges.get(column);
	}


	public Class getType() {
		return column.getJavaType();
	}
}
