package org.kobjects.jdbc.sql;

import org.kobjects.util.Strings;

/**
 * @author Stefan Haustein
 */
public class ConstantExpr extends Expression {

	Object value;

	public ConstantExpr(Object value) {
		this.value = value;
	}

	public Object eval(int rowNumber, Object[] rowData) {
		return value;
	}

	public String toString(int sqlType) {
		if (value == null) return "NULL";
		if (value instanceof String) return "'" + Strings.replace((String) value, "'", "''") + "'";
		//if (value instanceof Double) return
		return value.toString();
	}

	public Class getType() {
		return value == null ? Object.class : value.getClass();
	}


}
