package org.kobjects.jdbc.sql;

import java.sql.SQLException;
import java.util.Hashtable;

/**
 * @author Stefan Haustein
 */
public abstract class Expression {

	public static final int SQL92 = 0;
	public static final int ORACLE = 1;

	/**
	 * Returns range restrictions for this expression. The range
	 * restrictions may be more general than the (boolean) expression,
	 * but not more special.
	 *
	 * @param result A hashtable containing the range restrictions. The keys are Colum objects,
	 *               the values are Object arrays of size 2 containing the lower and upper bounds,
	 */

	public void getRangeRestrictions(Hashtable result) {
		return;
	}

	public abstract Object eval(int rowNumber, Object[] rowData) throws SQLException;

	public abstract Class getType();

	public String toString() {
		return toString(SQL92);
	}

	public abstract String toString(int sqlType);
}
