/*
 * Created on 29.05.2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.kobjects.jdbc.sql;

import java.sql.SQLException;

/**
 * @author haustein
 *         <p/>
 *         To change the template for this generated type comment go to
 *         Window>Preferences>Java>Code Generation>Code and Comments
 */
public class LikeExpr extends Expression {

	Expression valueExpr;
	Expression patternExpr;
	Expression escapeExpr;

	public LikeExpr(Expression valueExpr, Expression patternExpr, Expression escapeExpr) {
		this.valueExpr = valueExpr;
		this.patternExpr = patternExpr;
		this.escapeExpr = escapeExpr;
	}


	public boolean like(String value, String pattern, int escape) {
		int vi = 0;
		int pi = 0;


		int pl = pattern.length();
		int vl = value.length();

		while (pi < pl) {
			int pc = pattern.charAt(pi++);
			if (pc == '%') {
				if (pi == pl) return true;
				String subPattern = pattern.substring(pi);
				for (int i = vi; i <= vl; i++)
					if (like(value.substring(i), subPattern, escape))
						return true;

				return false;
			}

			if (vi >= vl) return false;

			if (pc == '_') {
				vi++;
			} else {
				if (pc == escape)
					pc = pattern.charAt(pi++);

				if (pc != value.charAt(vi++)) return false;
			}
		}

		return vi == vl;
	}

	/* (non-Javadoc)
	 * @see org.kobjects.jdbc.sql.Expression#eval(int)
	 */
	public Object eval(int rowNumber, Object[] rowData) throws SQLException {

		String value = (String) valueExpr.eval(rowNumber, rowData);
		if (value == null) return null;
		String pattern = (String) patternExpr.eval(rowNumber, rowData);
		if (pattern == null) return null;
		String escape = escapeExpr == null ? null : (String) escapeExpr.eval(rowNumber, rowData);

		int escCode;

		if (escape == null)
			escCode = -1;
		else {
			if (escape.length() != 1)
				throw new RuntimeException("illegal escape char: '" + escape + "'");

			escCode = escape.charAt(0);
		}

		return like(value, pattern, escCode)
				? Boolean.TRUE
				: Boolean.FALSE;
	}


	/* (non-Javadoc)
	 * @see org.kobjects.jdbc.sql.Expression#getType()
	 */
	public Class getType() {
		return Boolean.class;
	}


	/* (non-Javadoc)
		 * @see org.kobjects.jdbc.sql.Expression#toString(int)
		 */
	public String toString(int sqlType) {

		return " ( " + valueExpr.toString(sqlType) + " LIKE " + patternExpr.toString(sqlType) + (escapeExpr != null ? " ESCAPE " + escapeExpr.toString(sqlType) : "") + " ) ";
	}
}
