package org.kobjects.jdbc.sql;

import java.sql.SQLException;

/**
 * @author Stefan Haustein
 */
public class NotExpr extends Expression {


	Expression operand;

	NotExpr(Expression operand) {
		this.operand = operand;
	}

	public Object eval(int rowNumber, Object[] rowData) throws SQLException {
		Object val = operand.eval(rowNumber, rowData);

		return val == null
				? null
				: (((Boolean) val).booleanValue() ? Boolean.FALSE : Boolean.TRUE);
	}

	public String toString(int sqlType) {
		return " ( NOT (" + operand.toString(sqlType) + " ) ";
	}

	/* (non-Javadoc)
		 * @see org.kobjects.jdbc.sql.Expression#getType()
		 */
	public Class getType() {
		return Boolean.class;
	}

}
